require "fileutils"

rbdir = get_config("rbdir")
rubypath = get_config("rubypath")

encoding, kcode = \
  case get_config("encoding")
  when /.*euc[-_]?jp$/;	   ["euc-jp", "e"]
  when /.*shift[-_]?jis$/; ["Shift_JIS", "s"]
  else;			   ["utf-8", "n"]
  end

FileUtils.rm_rf("./vikiwiki")

# ==========================================================
# pre-config.rb -- preload script of "setup.rb config".
#
# Copyright (C) 2005 Z80-OOLONG. (NAKATSUKA, Yukitaka)
# ==========================================================

open("./config.rb", "w") do |cf|
  cf.print(<<-EOCODE)
# Environment Setting
$KCODE          = "#{kcode}"
$VIKIWIKIENCODE = "#{encoding}"
$VIKIWIKIDIR    = "#{rbdir}/vikiwiki"
$VIKIWIKITMP    = "/tmp"
$VIKIWIKIRUBY   = "#{rubypath}"
$VIKIWIKIOUT    = $>
  EOCODE
end

# ==========================================================
