# ==========================================================
# pre-setup.rb -- preload script of "setup.rb setup".
#
# Copyright (C) 2005 Z80-OOLONG. (NAKATSUKA, Yukitaka)
# ==========================================================

require "fileutils"
require "find"
require "digest/md5"

# ----------------------------------------------------------

FileUtils.rm_rf("../src/vikiwiki")

WGET = get_config("wgetprog")
UNZIP = get_config("unzipprog")
RUBY  = get_config("rubyprog")
NKF = get_config("nkfprog")

vikiwiki_uri = get_config("vikiwikiuri")
vikiwiki_uri.gsub!(%r[.*(https?|ftp)\:/+(.*)], '\1://\2')

kcode = case get_config("encoding")
        when /.*euc[-_]?jp$/i;    "e"
        when /.*shift[-_]?jis$/i; "s"
        else;                     "u"
        end

# ----------------------------------------------------------

if !File.file?("../src/vikiwiki.zip") then
  system("#{WGET} -O ../src/vikiwiki.zip #{vikiwiki_uri}")
end
system("#{UNZIP} ../src/vikiwiki.zip -d ../src")

# if vikiwiki.zip is vikiwiki2.zip...
if File.directory?("../src/vikiwiki2")
  FileUtils.mv("../src/vikiwiki2", "../src/vikiwiki")
end

FileUtils.cp_r("../src/vikiwiki/vikiwiki", "./vikiwiki")
FileUtils.mv("./config.rb", "./vikiwiki")

# Fix vikiwiki/setup.rb

Dir.chdir("../src/vikiwiki") do
  if !File.file?("./setup.rb") && File.file?("./setup.cgi") then
    FileUtils.mv("../vikiwiki-setup-cgi.txt", "../vikiwiki-setup-cgi.txt.tmp")
    open("../vikiwiki-setup-cgi.txt", "w") do |fout|
      File.foreach("../vikiwiki-setup-cgi.txt.tmp") do |line|
        line.gsub!(/^%CWD%\/vikiwiki/, Dir::pwd)
        fout.print(line)
      end
    end
    FileUtils.rm("../vikiwiki-setup-cgi.txt.tmp")
    FileUtils.mv("./setup.cgi", "./setup.cgi.tmp")
    open("./setup.cgi", "w") do |fout|
      File.foreach("./setup.cgi.tmp") do |line|
        line.gsub!(/^(DEFAULT_CONF\['TOPPAGE'\]\s*=.*)$/,
                   "\\1\nDEFAULT_CONF['$VIKIWIKIBASE'] = '#{Dir::pwd}'\n")
        fout.print(line)
      end
    end
    FileUtils.rm("./setup.cgi.tmp")
    system("#{RUBY} -Ku ./setup.cgi < ../vikiwiki-setup-cgi.txt")
  else
    FileUtils.mv("./setup.rb", "./setup.rb.tmp")
    open("./setup.rb", "w") do |fout|
      File.foreach("./setup.rb.tmp") do |line|
        line.gsub!(/^\$:\.unshift\('vikiwiki/, "$:.unshift('./vikiwiki")
        line.gsub!(/^(\s*\$CONF\['AUTHOR'\]\s*=.*)$/,
                   "\\1\n\t\t$CONF['ADDRESS']  = ''\n")
        fout.print(line)
      end
    end
    FileUtils.rm("./setup.rb.tmp")
    system("#{RUBY} -Ku ./setup.rb < ../vikiwiki-setup.txt")
  end
end

if (kcode != "u") then
  Find.find("./vikiwiki") do |f|
    if /.*(\.txt|\.r.*|\.css)$/ =~ f then
      print "convert encoding ... "
      system("#{NKF} -d -#{kcode} --overwrite #{f}")
      print "#{f}.\n"
    end
  end
end

$:.unshift("./vikiwiki", "./vikiwiki/lib")
load "./vikiwiki/vikiwikisys.rb"

FileUtils.cp("../src/vikiwiki.rb", "./vikiwiki.rb")
if /^1\.8.*/ === $WIKIVERSION then
  FileUtils.cp("../src/webrick.rb", "./vikiwiki/lib/webrickextend.rb")
  FileUtils.cp("../src/erb.rb", "./vikiwiki/lib/erbextend.rb")
elsif /^1\.9.*/ === $WIKIVERSION then
  FileUtils.cp("../src/webrick.rb", "./vikiwiki/lib/extension/webrick.rb")
  FileUtils.cp("../src/erb.rb", "./vikiwiki/lib/extension/erb.rb")
end

FileUtils.rm_f("./vikiwiki/master/vikiwiki.cgi")

# ==========================================================
